<template>
  <rui-loading v-if="loading" text="Loading example..." />
  <rui-alert v-else-if="error" variant="danger">{{ error }}</rui-alert>

  <example-wrapper>
    <component :is="exampleComponent" v-if="fileType==='vue' && exampleComponent" />
    <v-html v-else-if="fileType === 'html' && source" :html="source" />
  </example-wrapper>

  <template v-if="source">
    <h3>Source</h3>
    <code-block-renderer language="xml">{{ source }}</code-block-renderer>
  </template>
</template>

<script>
import VHtml from './VHtml.js'
import CodeBlockRenderer from './CodeBlockRenderer.vue'
import ExampleWrapper from './ExampleWrapper.vue'

/**
 * This component is responsible for displaying an example : a rendered component and its source.
 *
 * It handles Vue and HTML files.
 */
export default {
  name: 'ExampleRenderer',
  components: { ExampleWrapper, CodeBlockRenderer, VHtml },
  props: {
    /** Example path, without the extension, and relative to the `examples` directory */
    file: { required: true, type: String },
    /** Example extension */
    fileType: { required: true, type: String, validate: (v) => (['vue', 'html'].includes(v)) },
  },
  data () {
    return {
      loading: false,
      error: null,
      // Data
      exampleComponent: null,
      source: null,
      componentName: this.file.split('/')[0],
    }
  },
  created () {
    this.loading = true
    const chunks = this.file.split('/')

    const loaders = [
      // Source
      import(`../examples/${chunks[0]}/${chunks[1]}.${this.fileType}?raw`)
        .then((r) => { this.source = r.default })
        .catch((err) => { this.error = err }),
    ]

    // Component
    if (this.fileType === 'vue') {
      loaders.push(import(`../examples/${chunks[0]}/${chunks[1]}.${this.fileType}`)
        .then((r) => { this.exampleComponent = r.default })
        .catch((err) => { this.error = err }))
    } else {
      this.exampleComponent = 'v-html'
    }

    Promise.all(loaders)
      .catch((err) => { this.error = `Error loading example: ${this.file}: ${err}` })
      .then(() => { this.loading = false })
  },
}
</script>
